//Torpedo.cs

datablock AudioProfile(TorpedoExplosionSound)
{
   filename    = "Add-ons/Weapon_Rocket Launcher/tntExplode.wav";
   description = AudioClose3d;
   preload = false;
};

datablock AudioProfile(TorpedoFireSound)
{
   filename    = "Add-ons/Weapon_Spear/SpearFire.wav";
   description = AudioClose3d;
   preload = true;
};

//Torpedo trail
datablock ParticleData(TorpedoTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS			= 600;
	lifetimeVarianceMS	= 0;
	spinSpeed			= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha			= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/ring";
	//animTexName		= " ";

	// Interpolation variables
	colors[0]	= "0.75 0.75 0.75 0.3";
	colors[1]	= "0.75 0.75 0.75 0.2";
	colors[2]	= "1 1 1 0.0";
	sizes[0]	= 0.15;
	sizes[1]	= 0.35;
	sizes[2]	= 0.05;
	times[0]	= 0.0;
	times[1]	= 0.1;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(TorpedoTrailEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = TorpedoTrailParticle;
};


//effects
datablock ParticleData(TorpedoExplosionParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.9 0.9 0.6 0.9";
	colors[1]     = "0.9 0.5 0.6 0.0";
	sizes[0]      = 10.0;
	sizes[1]      = 15.0;

	useInvAlpha = true;
};
datablock ParticleEmitterData(TorpedoExplosionEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 1.0;
   ejectionOffset   = 3.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "rocketExplosionParticle";
};


datablock ParticleData(TorpedoExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 40;
	lifetimeVarianceMS   = 10;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 0.5 0.2 0.5";
	colors[1]     = "0.9 0.0 0.0 0.0";
	sizes[0]      = 8;
	sizes[1]      = 13;

	useInvAlpha = false;
};
datablock ParticleEmitterData(TorpedoExplosionRingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 0.0;
   ejectionOffset   = 3.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "rocketExplosionRingParticle";
};

datablock ExplosionData(TorpedoExplosion)
{
   //explosionShape = "";
   explosionShape = "Add-ons/Weapon_Rocket Launcher/explosionSphere1.dts";
	soundProfile = rocketExplodeSound;

   lifeTimeMS = 150;

   particleEmitter = rocketExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   emitter[0] = rocketExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "2 2 2";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.5;
   camShakeRadius = 20.0;

   // Dynamic light
   lightStartRadius = 5;
   lightEndRadius = 20;
   lightStartColor = "1 1 1 1";
   lightEndColor = "0 0 0 0";

   damageRadius = 15;
   radiusDamage = 200;

   impulseRadius = 20;
   impulseForce = 7000;
};

//projectile
AddDamageType("TorpedoDirect",   '<bitmap:add-ons/Weapon_Bombs/CI_Bomb> %1',       '%2 <bitmap:add-ons/Weapon_Bombs/CI_Bomb> %1',1,1);
AddDamageType("TorpedoRadius",   '<bitmap:add-ons/Weapon_Bombs/CI_BombRadius> %1', '%2 <bitmap:add-ons/Weapon_Bombs/CI_BombRadius> %1',1,0);
datablock ProjectileData(TorpedoProjectile)
{
   projectileShapeName = "./Torpedo.dts";
   directDamage        = 100;
   directDamageType  	= $DamageType::TorpedoDirect;
   radiusDamageType  	= $DamageType::TorpedoRadius;
   impactImpulse	   	= 0;
   verticalImpulse	= 0;
   explosion           = TorpedoExplosion;
   particleEmitter     = TorpedoTrailEmitter;

   brickExplosionRadius = 10;
   brickExplosionImpact = true; //destroy a brick if we hit it directly?
   brickExplosionForce  = 50;
   brickExplosionMaxVolume = 200;
   brickExplosionMaxVolumeFloating = 200;

   muzzleVelocity      = 25;
   velInheritFactor    = 1;

   armingDelay         = 2;
   lifetime            = 20000;
   fadeDelay           = 19500;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod = 1.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Torpedo";
};


//////////
// item //
//////////
datablock ItemData(TorpedoItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Torpedo.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "A-P Bomb";
	iconName = "./icon_APBomb";
	doColorShift = false;
	colorShiftColor = "0.400 0.196 0 1.000";

	 // Dynamic properties defined by the scripts
	image = TorpedoImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(TorpedoImage)
{
   // Basic Item properties
   shapeFile = "base/data/shapes/empty.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 -3";
   //eyeOffset = "0.1 0.2 -0.55";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = TorpedoItem;
   ammo = " ";
   projectile = TorpedoProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = false;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = "0.400 0.196 0 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.1;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSequence[0]			= "ready";
	stateSound[0]			= weaponSwitchSound;

	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateAllowImageChange[1]	= true;
	
	stateName[2]			= "Fire";
	stateTransitionOnTimeout[2]	= "Ready";
	stateTimeoutValue[2]		= 0.9;
	stateFire[2]			= true;
	stateSequence[2]			= "fire";
	stateScript[2]			= "onFire";
	stateWaitForTimeout[2]		= true;
	stateAllowImageChange[2]	= false;
	stateSound[2]         = TorpedoFireSound;
};

package Weapon_Torpedo
{
	function TorpedoImage::onFire(%this,%obj,%slot)
	{
		if(!%obj.isMounted())
			return;
		Parent::onFire(%this,%obj,%slot);
	}
};
activatePackage(Weapon_Torpedo);
